void eepromTick() {
  if (eeprom_flag)
    if (millis() - eeprom_timer > 30000) {  // 30 секунд после последнего нажатия с пульта
      eeprom_flag = false;
      eeprom_timer = millis();
      updateEEPROM();
    }
}



void def_setup () {
  this_mode = 0;
  freq_strobe_mode = 0;
  light_mode = 1;
  RAINBOW_STEP = 5.5 ;
  MAX_COEF_FREQ = 1.5 ;
  STROBE_PERIOD = 100;
  LIGHT_SAT = 200;
  RAINBOW_STEP_2 = 5.5 ;
  HUE_START = 0 ;
  SMOOTH = 0.8 ;
  SMOOTH_FREQ = 0.9;
  STROBE_SMOOTH = 100;
  LIGHT_COLOR = 200;
  COLOR_SPEED = 100;
  RAINBOW_PERIOD = 3 ;
  RUNNING_SPEED = 60;
  HUE_STEP = 5;
  EMPTY_BRIGHT = 30;
  BRIGHTNESS = 150;  
  updateEEPROM() ;
    
}

void updateEEPROM() {
  EEPROM.updateByte(1, this_mode);
  EEPROM.updateByte(2, freq_strobe_mode);
  EEPROM.updateByte(3, light_mode);
  EEPROM.updateInt(4, RAINBOW_STEP);
   EEPROM.updateFloat(8, MAX_COEF_FREQ);
  EEPROM.updateInt(12, STROBE_PERIOD);
  EEPROM.updateInt(16, LIGHT_SAT);
  EEPROM.updateFloat(20, RAINBOW_STEP_2);
  EEPROM.updateInt(24, HUE_START);
  EEPROM.updateFloat(28, SMOOTH);
  EEPROM.updateFloat(32, SMOOTH_FREQ);
  EEPROM.updateInt(36, STROBE_SMOOTH);
  EEPROM.updateInt(40, LIGHT_COLOR);
  EEPROM.updateInt(44, COLOR_SPEED);
  EEPROM.updateInt(48, RAINBOW_PERIOD);
  EEPROM.updateInt(52, RUNNING_SPEED);
  EEPROM.updateInt(56, HUE_STEP);
  EEPROM.updateInt(60, EMPTY_BRIGHT);
  EEPROM.updateByte(86, BRIGHTNESS);
 crc= (float) (EEPROM.readByte(1)+ EEPROM.readByte(2)+ EEPROM.readByte(3) +EEPROM.readByte(86)) ;
 crc=crc+ (float)( EEPROM.readInt(4) +EEPROM.readInt(12)+EEPROM.readInt(16)+EEPROM.readInt(24)+ 
 EEPROM.readInt(40)+ EEPROM.readInt(44)+ EEPROM.readInt(48)+ EEPROM.readInt(52)+
  EEPROM.readInt(56)+EEPROM.readInt(60));
  crc=crc+ EEPROM.readFloat(8)+  EEPROM.readFloat(20)+ EEPROM.readFloat(28)+ EEPROM.readFloat(32);
      
  EEPROM.updateFloat(100, crc);
  if (KEEP_STATE) EEPROM.updateByte(66, ONstate);
}
void readEEPROM() {
  this_mode = EEPROM.readByte(1);
  freq_strobe_mode = EEPROM.readByte(2);
  light_mode = EEPROM.readByte(3);
  RAINBOW_STEP = EEPROM.readInt(4);
  MAX_COEF_FREQ = EEPROM.readFloat(8);
  STROBE_PERIOD = EEPROM.readInt(12);
  LIGHT_SAT = EEPROM.readInt(16);
  RAINBOW_STEP_2 = EEPROM.readFloat(20);
  HUE_START = EEPROM.readInt(24);
  SMOOTH = EEPROM.readFloat(28);
  SMOOTH_FREQ = EEPROM.readFloat(32);
  STROBE_SMOOTH = EEPROM.readInt(36);
  LIGHT_COLOR = EEPROM.readInt(40);
  COLOR_SPEED = EEPROM.readInt(44);
  RAINBOW_PERIOD = EEPROM.readInt(48);
  RUNNING_SPEED = EEPROM.readInt(52);
  HUE_STEP = EEPROM.readInt(56);
  EMPTY_BRIGHT = EEPROM.readInt(60);
  BRIGHTNESS = EEPROM.readByte(86);

  if (KEEP_STATE) ONstate = EEPROM.readByte(64);
}
